// Baton Item

// Datablocks
datablock ProjectileData(BatonProjectile : hammerProjectile)
{
	directDamage = 0;
	lifeTime = 150;
	explodeOnDeath = false;
};

datablock ItemData(BatonItem : hammerItem)
{
	category = "Weapon";
	className = "Weapon";
	uiName = "Baton";
	canDrop = true;
	noSpawn = true;
	image = BatonImage;
	doColorShift = true;
	colorShiftColor = "0.898039 0.898039 0.00000 1.000000";
};

datablock ShapeBaseImageData(BatonImage : hammerImage)
{
	className = "WeaponImage";
	rotation = "0 1 0 0";
	item = BatonItem;
	projectile = BatonProjectile;
	projectileType = Projectile;
	colorShiftColor = "0.898039 0.898039 0.00000 1.000000";
};

// Functions

function BatonImage::onFire(%datablock, %obj, %slot)
{
	Parent::onFire(%datablock, %obj, %slot);
	
	%obj.playThread(2, "armAttack");
}

function BatonImage::onStopFire(%datablock, %obj, %slot)
{
	%obj.playThread(2, "root");
}

function BatonProjectile::onCollision(%projectile, %obj, %col, %fade, %pos, %normal)
{
	%client = %obj.sourceObject.client;
	// May only be used when the RP is online
	if (isObject(%col) && isObject(%client) && %client.isInRP())
	{
		// Do stuff on player
		if (%col.getType() & $TypeMasks::PlayerObjectType)
			%col.onUseBaton(%client);
		// Do stuff on brick
		else if (%col.getType() & $TypeMasks::fxBrickObjectType)
		{
			// Open door
			if (isObject(%col.shape))
				%col.onBashDoor(%client);
			// Open safe
			else if (%col.isSafe)
				%col.onOpenSafe(%client);
		}
	}
	serverPlay3D(hammerHitSound, %pos);
}